// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _CAMERA_H_
#define _CAMERA_H_

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glu.h>

#include "coord.h"
#include "node.h"

namespace SceneGraph
{

class cCamera : public cNode
{
private:
 float _fovy;
 float _ratio;
 float _near;
 float _far;

 cCoord _pos;
 cCoord _center;
 cCoord _up;

public:
 cCamera(string label, float fovy, float ratio, float n, float f, cCoord pos, cCoord center, cCoord up) : 
 cNode(label, cNode::CAMERA), _fovy(fovy), _ratio(ratio), _near(n), _far(f), _pos(pos), _center(center), _up(up) {}

 void fovy(float v) { _fovy = v; }

 void ratio(float v) { _ratio = v; }

 void setNear(float v) { _near = v; }

 void setFar(float v) { _far = v; }

 void pos(cCoord p) { _pos = p; }

 void center(cCoord c) { _center = c; }

 void up(cCoord u) { _up = u; }

 int SetupCamera(void);

};

}

#endif
