// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#include "entity.h"
#include "material.h"

namespace SceneGraph
{

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
cEntity::~cEntity()
{
 if(_shape)
  delete _shape;
 if(_app)
  delete _app;
 if(_tex)
  delete _tex;
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cEntity::Render(bool opaque)
{
 cMaterial* mat = NULL;
 mat = (cMaterial*)_app;
 if(mat && mat->opaque() != opaque)
  return;
 
 if(_app)
  _app->Load();

 if(_tex)
 {
  _tex->Load();
  if(_shape)
   _shape->drawTexture();
  _tex->Unload();
 }
 else
 {
  if(_shape)
  _shape->draw();
 }

 if(_app)
  _app->Unload();
}

}
