// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _ENTITY_H_
#define _ENTITY_H_

#include "node.h"
#include "shape.h"
#include "appearance.h"
#include "texture.h"

namespace SceneGraph
{

class cEntity : public cNode
{
private:
 cShape* _shape;
 cAppearance* _app;
 cTexture* _tex;

public:
 cEntity(string label) : cNode(label, cNode::ENTITY) , _shape(NULL), _app(NULL), _tex(NULL) {}
 cEntity(string label, cShape* sp, cAppearance* app) : cNode(label, cNode::ENTITY) , _shape(sp), _app(app), _tex(NULL) {}
 ~cEntity();

 void SetShape(cShape* sp) { _shape = sp; }
 cShape* GetShape(void) { return _shape; }

 void SetApp(cAppearance* app) { _app = app; }
 cAppearance* GetApp(void) { return _app; }

 void SetTexture(cTexture* tex) { _tex = tex; }
 cTexture* GetTexture(void) { return _tex; }

 void Render(bool);
};

}

#endif
