// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _GROUP_H_
#define _GROUP_H_

#include <map>
#include <string>

#include "node.h"

using std::map;
using std::string;

namespace SceneGraph
{

class cGroup : public cNode
{
protected:
 map<string, cNode*> _children;

public:
 cGroup(string label, int type) : cNode(label, type) {}
 cGroup(string label, int type, map<string, cNode*> vec) : cNode(label, type), _children(vec) {}
 ~cGroup() {}

 void addChild(string label, cNode* c) { _children[label] = c; }

 cNode* getChild(string label) { return _children[label]; }

 void Free(void);

};

}

#endif
