// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#include "light.h"

namespace SceneGraph
{

int cLight::_nextLightId = 0;

//------------------------------------------------------------
//------------------------------------------------------------
cLight::cLight(string label, float* pos, float* amb, float* diff, float* spec) : cNode(label, cNode::LIGHT)
{
 _lightId = _nextLightId;
 _nextLightId++;

 for(int i = 0; i < 4; i++)
 {
  _pos[i] = pos[i];
  _ambient[i] = amb[i];
  _diffuse[i] = diff[i];
  _specular[i] = spec[i];
 }
}

//------------------------------------------------------------
//------------------------------------------------------------
void cLight::ambient(float* amb)
{
 for(int i = 0; i < 4; i++)
  _ambient[i] = amb[i];
}

//------------------------------------------------------------
//------------------------------------------------------------
void cLight::diffuse(float* diff)
{
 for(int i = 0; i < 4; i++)
  _diffuse[i] = diff[i];
}

//------------------------------------------------------------
//------------------------------------------------------------
void cLight::specular(float* spec)
{
 for(int i = 0; i < 4; i++)
  _specular[i] = spec[i];
}

//------------------------------------------------------------
//------------------------------------------------------------
void cLight::pos(float* pos)
{
 for(int i = 0; i < 4; i++)
  _pos[i] = pos[i];
}

//------------------------------------------------------------
//------------------------------------------------------------
int cLight::SetupLights(void)
{
 glLightfv(GL_LIGHT0+_lightId, GL_AMBIENT, _ambient);
 glLightfv(GL_LIGHT0+_lightId, GL_DIFFUSE, _diffuse);
 glLightfv(GL_LIGHT0+_lightId, GL_SPECULAR, _specular);
 glLightfv(GL_LIGHT0+_lightId, GL_POSITION, _pos);

 glEnable(GL_LIGHTING);
 glEnable(GL_LIGHT0+_lightId);
 glEnable(GL_DEPTH_TEST);

 return 1;
}

}
