// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _LIGHT_H_
#define _LIGHT_H_

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>

#include "node.h"

namespace SceneGraph
{

class cLight : public cNode
{
private:
 int _lightId;
 static int _nextLightId;

 float _ambient[4];
 float _diffuse[4];
 float _specular[4];

 float _pos[4];

public:
 cLight(string label, float* pos, float* amb, float* diff, float* spec);
 ~cLight() {}

 void ambient(float* amb);

 void diffuse(float* diff);

 void specular(float* spec);

 void pos(float* pos);

 int SetupLights(void);
};

}

#endif
