// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/glut.h>

#include <iup.h>
#include <iupgl.h>
#include <iupcontrols.h>

#include "util.h"

static Ihandle* canvas;

extern void setMainDialogCB(Ihandle*);
extern void SetExecPath(char* s);

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* InitMainDialog(void)
{
 canvas = NULL;
 canvas = IupGLCanvas(NULL);
  
 IupSetAttribute(canvas, "BUFFER", "DOUBLE");
 IupSetAttribute(canvas, "COLOR", "RGBA");
 IupSetAttribute(canvas, "RASTERSIZE", "600x480");

 Ihandle* menu = Att("menu", 
  IupMenu(
   IupSubmenu("File",
   IupMenu(
    Att("load_triangles_mesh_it",
     IupItem("Load triangles mesh...", "OpenTriangles"),
    NULL),
    Att("load_quadrilaterum_mesh_it",
     IupItem("Load tetrahedrons mesh...", "OpenTetrahedrons"),
     "ACTIVE", "NO",
    NULL),
   NULL)),
  NULL),
 NULL);
   
 Ihandle* dlg = Att("dg_main",
  IupDialog
  (
   IupVbox
   (
    //menu,
    IupFill(),
    IupHbox
    (
     IupFill(),
     canvas,
     NULL
    ),
    IupFill(),
    NULL
   )
  ),
  IUP_TITLE, "Scene Graph",
  IUP_CLOSE_CB, "Exit",
  "RESIZE", "NO",
  "MAXBOX", "NO",
  NULL
 );

 return dlg;
}

//-------------------------------------------
//-------------------------------------------
void ShowMainDialog(void)
{
 Ihandle* mainDialog = IupGetHandle("dg_main");
 if(!mainDialog)
 {
  mainDialog = InitMainDialog();
  setMainDialogCB(canvas);
  IupMap(mainDialog);
 }

 IupShowXY(mainDialog, IUP_CENTER, IUP_CENTER);
}

//-------------------------------------------
//-------------------------------------------
int main(int argc, char* argv[])
{
 IupOpen();
 IupGLCanvasOpen();
 IupControlsOpen();

 IupSetLanguage(IUP_ENGLISH);

 SetExecPath((char*)argv[0]);

 ShowMainDialog();

 IupMainLoop();
 IupClose();

 return 1;
}
