// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _MATERIAL_H_
#define _MATERIAL_H_

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>

#include "appearance.h"

namespace SceneGraph
{

class cMaterial : public cAppearance
{
private:
 float _ambient[4];
 float _diffuse[4];
 float _specular[4];
 float _shininess;

 bool _opaque;

public:
 cMaterial(float* amb, float* diff, float* spec, float shin);
 ~cMaterial() {}

 void ambient(float* amb);

 void diffuse(float* diff);

 void specular(float* spec);

 void shininess(float sh) { _shininess = sh; }

 bool opaque(void) { return _opaque; }

 void Load(void);
 void Unload(void);
};

}

#endif
