// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _NODE_H_
#define _NODE_H_

#include <string>

using std::string;

namespace SceneGraph
{

class cNode
{
private:
 //node id
 int _id;
 static int _nextId;

 //node label
 string _label;

 //node type
 int _type;

public:
 cNode(string label, int type);
 ~cNode() {}

 //node type
 enum { SCENE = 1, CAMERA, LIGHT, TRANSFORM, GROUP, ENTITY };

 int id(void) { return _id; }

 string label(void) { return _label; }
 void label(string l) { _label = l; }

 //only camera node do
 virtual int SetupCamera(void) { return 0; }
 
 //only light node do
 virtual int SetupLights(void) { return 0; }

 //only entity node do
 virtual void Render(bool) { }
 virtual void Render(void) { }
};

}

#endif
