// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _SCENE_H_
#define _SCENE_H_

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>

#include "camera.h"
#include "light.h"
#include "entity.h"
#include "transform.h"
#include "appearance.h"
#include "material.h"
#include "shape.h"
#include "mesh.h"
#include "group.h"
#include "texture.h"

namespace SceneGraph
{

class cScene : public cGroup
{
private:
 float _clearColor[4];

public:
 cScene(string label, float* rgba);
 cScene(string label, map<string, cNode*> vec, float* rgba);
 ~cScene() { Free(); }

 int SetupCamera(void);

 int SetupLights(void);

 void Render(void);

};

}

#endif
