// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glut.h>

#include "shape.h"

namespace SceneGraph
{

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cLine::draw(void)
{
 glBegin(GL_LINE);
  glVertex3f(_p1.x, _p1.y, _p1.z);
  glVertex3f(_p2.x, _p2.y, _p2.z);
 glEnd();
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cTriangle::draw(void)
{
 glBegin(GL_TRIANGLES);
  glVertex3f(_p1.x, _p1.y, _p1.z);
  glVertex3f(_p2.x, _p2.y, _p2.z);
  glVertex3f(_p3.x, _p3.y, _p3.z);
 glEnd();
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cCube::draw(void)
{
 if(_solid)
  glutSolidCube(_dimension);
 else
  glutWireCube(_dimension);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cSphere::draw(void)
{
 if(_solid)
  glutSolidSphere(_radius, _slices, _stacks);
 else
  glutWireSphere(_radius, _slices, _stacks);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cRect::draw(void)
{
 glEnable(GL_CULL_FACE);
 glCullFace(GL_BACK);
 //x positivo
 glNormal3f(1.0, 0.0, 0.0);
 glBegin(GL_QUADS);
  glVertex3f(_dx, _dy, _dz);
  glVertex3f(_dx, -_dy, _dz);
  glVertex3f(_dx, -_dy, -_dz);
  glVertex3f(_dx, _dy, -_dz);
 glEnd();

 //x negativo
 glNormal3f(-1.0, 0.0, 0.0);
 glBegin(GL_QUADS);
  glVertex3f(-_dx, _dy, _dz);
  glVertex3f(-_dx, _dy, -_dz);
  glVertex3f(-_dx, -_dy, -_dz);
  glVertex3f(-_dx, -_dy, _dz);
 glEnd();

 //y positivo
 glNormal3f(0.0, 1.0, 0.0);
 glBegin(GL_QUADS);
  glVertex3f(_dx, _dy, _dz);
  glVertex3f(_dx, _dy, -_dz);
  glVertex3f(-_dx, _dy, -_dz);
  glVertex3f(-_dx, _dy, _dz);
 glEnd();

 //y negativo
 glNormal3f(0.0, -1.0, 0.0);
 glBegin(GL_QUADS);
  glVertex3f(_dx, -_dy, _dz);
  glVertex3f(-_dx, -_dy, _dz);
  glVertex3f(-_dx, -_dy, -_dz);
  glVertex3f(_dx, -_dy, -_dz);
 glEnd();

 //z positivo
 glNormal3f(0.0, 0.0, 1.0);
 glBegin(GL_QUADS);
  glVertex3f(_dx, _dy, _dz);
  glVertex3f(-_dx, _dy, _dz);
  glVertex3f(-_dx, -_dy, _dz);
  glVertex3f(_dx, -_dy, _dz);
 glEnd();

 //z negativo
 glNormal3f(0.0, 0.0, -1.0);
 glBegin(GL_QUADS);
  glVertex3f(_dx, _dy, -_dz);
  glVertex3f(_dx, -_dy, -_dz);
  glVertex3f(-_dx, -_dy, -_dz);
  glVertex3f(-_dx, _dy, -_dz);
 glEnd();

 glDisable(GL_CULL_FACE);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cRect::drawTexture(void)
{
 glEnable(GL_CULL_FACE);
 glCullFace(GL_BACK);
 //x positivo
 glNormal3f(1.0, 0.0, 0.0);
 glBegin(GL_QUADS);
  glTexCoord2f(0.0, 0.0); glVertex3f(_dx, _dy, _dz);
  glTexCoord2f(0.0, 1.0); glVertex3f(_dx, -_dy, _dz);
  glTexCoord2f(1.0, 1.0); glVertex3f(_dx, -_dy, -_dz);
  glTexCoord2f(1.0, 0.0); glVertex3f(_dx, _dy, -_dz);
 glEnd();

 //x negativo
 glNormal3f(-1.0, 0.0, 0.0);
 glBegin(GL_QUADS);
  glTexCoord2f(1.0, 0.0); glVertex3f(-_dx, _dy, _dz);
  glTexCoord2f(0.0, 0.0); glVertex3f(-_dx, _dy, -_dz);
  glTexCoord2f(0.0, 1.0); glVertex3f(-_dx, -_dy, -_dz);
  glTexCoord2f(1.0, 1.0); glVertex3f(-_dx, -_dy, _dz);
 glEnd();

 //y positivo
 glNormal3f(0.0, 1.0, 0.0);
 glBegin(GL_QUADS);
  glTexCoord2f(1.0, 0.0); glVertex3f(_dx, _dy, _dz);
  glTexCoord2f(0.0, 0.0); glVertex3f(_dx, _dy, -_dz);
  glTexCoord2f(0.0, 1.0); glVertex3f(-_dx, _dy, -_dz);
  glTexCoord2f(1.0, 1.0); glVertex3f(-_dx, _dy, _dz);
 glEnd();

 //y negativo
 glNormal3f(0.0, -1.0, 0.0);
 glBegin(GL_QUADS);
  glTexCoord2f(1.0, 0.0); glVertex3f(_dx, -_dy, _dz);
  glTexCoord2f(0.0, 0.0); glVertex3f(-_dx, -_dy, _dz);
  glTexCoord2f(0.0, 1.0); glVertex3f(-_dx, -_dy, -_dz);
  glTexCoord2f(1.0, 1.0); glVertex3f(_dx, -_dy, -_dz);
 glEnd();

 //z positivo
 glNormal3f(0.0, 0.0, 1.0);
 glBegin(GL_QUADS);
  glTexCoord2f(1.0, 0.0); glVertex3f(_dx, _dy, _dz);
  glTexCoord2f(0.0, 0.0); glVertex3f(-_dx, _dy, _dz);
  glTexCoord2f(0.0, 1.0); glVertex3f(-_dx, -_dy, _dz);
  glTexCoord2f(1.0, 1.0); glVertex3f(_dx, -_dy, _dz);
 glEnd();

 //z negativo
 glNormal3f(0.0, 0.0, -1.0);
 glBegin(GL_QUADS);
  glTexCoord2f(1.0, 0.0); glVertex3f(_dx, _dy, -_dz);
  glTexCoord2f(0.0, 0.0); glVertex3f(_dx, -_dy, -_dz);
  glTexCoord2f(0.0, 1.0); glVertex3f(-_dx, -_dy, -_dz);
  glTexCoord2f(1.0, 1.0); glVertex3f(-_dx, _dy, -_dz);
 glEnd();

 glDisable(GL_CULL_FACE);
}

}
