// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#include "texture.h"

namespace SceneGraph
{

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
cTexture::cTexture(string filename)
{
 _filename = filename;

 _mode = cTexture::MODULATE;

 glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  
 AUX_RGBImageRec* texture = NULL;
 texture = auxDIBImageLoad((char*)_filename.c_str());

 if(texture)
 {
  glGenTextures(1, &_texName);
  glBindTexture(GL_TEXTURE_2D, _texName);
  glTexImage2D(GL_TEXTURE_2D, 0, 3, texture->sizeX, texture->sizeY,
   0, GL_RGB, GL_UNSIGNED_BYTE, texture->data);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

  free(texture->data);
  free(texture);
 }
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cTexture::Load(void)
{
 glEnable(GL_TEXTURE_2D);

 if(_mode == cTexture::MODULATE)
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
 else
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

 bool istexture = false;
 GLuint* pname = &_texName;
 glAreTexturesResident(1, pname, (GLboolean*)&istexture);
 glBindTexture(GL_TEXTURE_2D, _texName);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void cTexture::Unload(void)
{
 glDisable(GL_TEXTURE_2D);
}

}
