// ------------------------------------------------------------------------
// SceneGraph Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br/~lduarte
//
// $Source:  $
// $Revision: 1.0 $
// $Date: 2007/05/20 18:52:00 $
//
// $Author: lduarte $
// ------------------------------------------------------------------------

#ifndef _TRANSFORM_H_
#define _TRANSFORM_H_

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>

#include <vector>

#include "group.h"

using std::vector;

namespace SceneGraph
{

class cTransform : public cGroup
{
private:
 float _matrix[16];
 float _imatrix[16];

public:
 cTransform(string label) : cGroup(label, cNode::TRANSFORM) { LoadIdentity(); }
 cTransform(string label, map<string, cNode*> vec) : cGroup(label, cNode::TRANSFORM, vec) { LoadIdentity(); }
 ~cTransform() { Free(); }

 //initial value to _matrix
 void LoadIdentity(void);

 //modelview operators 
 void Translate(float dx, float dy, float dz);
 void Rotate(float angle, float rx, float ry, float rz);
 void Scale(float ax, float ay, float az);

 //setup the childrens camera
 int SetupCamera(void);

 //steup the childrens lights
 int SetupLights(void);

 //render all children
 void Render(bool);

};

}

#endif
